# swagger-java-client

TollGuru Calculator
- API version: 2020-05-31T17:48:12Z
  - Build date: 2020-07-14T10:23:31.922Z[GMT]

TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->

  For more information, please visit [tollguru.com](tollguru.com)

*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.GpsTracestracksApi;

import java.io.File;
import java.util.*;

public class GpsTracestracksApiExample {

    public static void main(String[] args) {
        
        GpsTracestracksApi apiInstance = new GpsTracestracksApi();
        Body1 body = new Body1(); // Body1 | 
        try {
            SyncResponse result = apiInstance.routeDownloadPost(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling GpsTracestracksApi#routeDownloadPost");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.GpsTracestracksApi;

import java.io.File;
import java.util.*;

public class GpsTracestracksApiExample {

    public static void main(String[] args) {
        
        GpsTracestracksApi apiInstance = new GpsTracestracksApi();
        String vehicleType = "vehicleType_example"; // String | 
        Object body = null; // Object | 
        String vehicleName = "vehicleName_example"; // String | Specify name for your vehicle to identify the response json for particular vehicle
        String height = "height_example"; // String | Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height
        String weight = "weight_example"; // String | Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight
        Boolean isAsync = false; // Boolean | The API will function in asynchronous mode is set to true
        try {
            InlineResponse2001 result = apiInstance.routeUploadPost(vehicleType, body, vehicleName, height, weight, isAsync);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling GpsTracestracksApi#routeUploadPost");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://dev.tollguru.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*GpsTracestracksApi* | [**routeDownloadPost**](docs/GpsTracestracksApi.md#routeDownloadPost) | **POST** /route/download | Download Async Results
*GpsTracestracksApi* | [**routeUploadPost**](docs/GpsTracestracksApi.md#routeUploadPost) | **POST** /route/upload | Request
*OriginAndDestinationPairApi* | [**gmapsPost**](docs/OriginAndDestinationPairApi.md#gmapsPost) | **POST** /gmaps | Google Maps Routes
*OriginAndDestinationPairApi* | [**herePost**](docs/OriginAndDestinationPairApi.md#herePost) | **POST** /here | HERE Maps Routes
*RoutePolylineApi* | [**routePost**](docs/RoutePolylineApi.md#routePost) | **POST** /route | Route polyline (from HERE/ Google map)

## Documentation for Models

 - [Address](docs/Address.md)
 - [AllOfGmapRequestBodyDriver](docs/AllOfGmapRequestBodyDriver.md)
 - [AllOfGmapRequestBodyFrom](docs/AllOfGmapRequestBodyFrom.md)
 - [AllOfGmapRequestBodyFuelEfficiency](docs/AllOfGmapRequestBodyFuelEfficiency.md)
 - [AllOfGmapRequestBodyHos](docs/AllOfGmapRequestBodyHos.md)
 - [AllOfGmapRequestBodyTo](docs/AllOfGmapRequestBodyTo.md)
 - [AllOfGmapRequestBodyVehicleType](docs/AllOfGmapRequestBodyVehicleType.md)
 - [AllOfHereRequestBodyDriver](docs/AllOfHereRequestBodyDriver.md)
 - [AllOfHereRequestBodyFrom](docs/AllOfHereRequestBodyFrom.md)
 - [AllOfHereRequestBodyFuelEfficiency](docs/AllOfHereRequestBodyFuelEfficiency.md)
 - [AllOfHereRequestBodyHos](docs/AllOfHereRequestBodyHos.md)
 - [AllOfHereRequestBodyTo](docs/AllOfHereRequestBodyTo.md)
 - [AllOfHereRequestBodyTruck](docs/AllOfHereRequestBodyTruck.md)
 - [AllOfHereRequestBodyVehicleType](docs/AllOfHereRequestBodyVehicleType.md)
 - [AllOfHereResponseSummaryFuelEfficiency](docs/AllOfHereResponseSummaryFuelEfficiency.md)
 - [AllOfHereResponseSummaryVehicleType](docs/AllOfHereResponseSummaryVehicleType.md)
 - [AnyOfbody](docs/AnyOfbody.md)
 - [AsyncResponse](docs/AsyncResponse.md)
 - [Body](docs/Body.md)
 - [Body1](docs/Body1.md)
 - [Cost](docs/Cost.md)
 - [Direction](docs/Direction.md)
 - [DirectionPosition](docs/DirectionPosition.md)
 - [Driver](docs/Driver.md)
 - [FuelEfficiency](docs/FuelEfficiency.md)
 - [GeoCordinates](docs/GeoCordinates.md)
 - [GmapRequestBody](docs/GmapRequestBody.md)
 - [GmapResponse](docs/GmapResponse.md)
 - [GmapRouteResponse](docs/GmapRouteResponse.md)
 - [HereRequestBody](docs/HereRequestBody.md)
 - [HereResponse](docs/HereResponse.md)
 - [HereResponseSummary](docs/HereResponseSummary.md)
 - [HereResponseSummaryFuelPrice](docs/HereResponseSummaryFuelPrice.md)
 - [HosData](docs/HosData.md)
 - [HosReq](docs/HosReq.md)
 - [HosResponse](docs/HosResponse.md)
 - [HosResponseSummary](docs/HosResponseSummary.md)
 - [HosResponseSummaryTotalDistance](docs/HosResponseSummaryTotalDistance.md)
 - [HosResponseSummaryTotalDriveDuration](docs/HosResponseSummaryTotalDriveDuration.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse200Route](docs/InlineResponse200Route.md)
 - [Location](docs/Location.md)
 - [OneOfGmapRequestBodyDepartureTime](docs/OneOfGmapRequestBodyDepartureTime.md)
 - [OneOfHereRequestBodyDepartureTime](docs/OneOfHereRequestBodyDepartureTime.md)
 - [OneOfLocation](docs/OneOfLocation.md)
 - [OneOfinlineResponse2001](docs/OneOfinlineResponse2001.md)
 - [PlaceId](docs/PlaceId.md)
 - [Rates](docs/Rates.md)
 - [Route](docs/Route.md)
 - [RouteLocation](docs/RouteLocation.md)
 - [RouteResponse](docs/RouteResponse.md)
 - [RouteResponseSummary](docs/RouteResponseSummary.md)
 - [RouteResponseSummaryDiffs](docs/RouteResponseSummaryDiffs.md)
 - [RouteResponseSummaryDistance](docs/RouteResponseSummaryDistance.md)
 - [RouteResponseSummaryDuration](docs/RouteResponseSummaryDuration.md)
 - [Stop](docs/Stop.md)
 - [SyncResponse](docs/SyncResponse.md)
 - [SyncResponseRoute](docs/SyncResponseRoute.md)
 - [SyncResponseSummary](docs/SyncResponseSummary.md)
 - [TeritoryMielageRes](docs/TeritoryMielageRes.md)
 - [TeritoryMielageResInner](docs/TeritoryMielageResInner.md)
 - [Toll](docs/Toll.md)
 - [Truck](docs/Truck.md)
 - [VehicleType](docs/VehicleType.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### authorizer

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

eng@tollguru.com
