# OriginAndDestinationPairApi

All URIs are relative to *https://dev.tollguru.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**gmapsPost**](OriginAndDestinationPairApi.md#gmapsPost) | **POST** /gmaps | Google Maps Routes
[**herePost**](OriginAndDestinationPairApi.md#herePost) | **POST** /here | HERE Maps Routes

<a name="gmapsPost"></a>
# **gmapsPost**
> GmapResponse gmapsPost(body)

Google Maps Routes

HTTP Request for cars, SUVs, pick-ups, motorcycles

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.OriginAndDestinationPairApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: authorizer
ApiKeyAuth authorizer = (ApiKeyAuth) defaultClient.getAuthentication("authorizer");
authorizer.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//authorizer.setApiKeyPrefix("Token");

OriginAndDestinationPairApi apiInstance = new OriginAndDestinationPairApi();
GmapRequestBody body = new GmapRequestBody(); // GmapRequestBody | 
try {
    GmapResponse result = apiInstance.gmapsPost(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OriginAndDestinationPairApi#gmapsPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GmapRequestBody**](GmapRequestBody.md)|  | [optional]

### Return type

[**GmapResponse**](GmapResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="herePost"></a>
# **herePost**
> HereResponse herePost(body)

HERE Maps Routes

&lt;p&gt;HTTP Request for trucks, buses, RVs, cars, SUV, pick-ups, motorcycles&lt;/p&gt;&lt;p&gt;For trucks you should specify truck weight, wherever possible. Some bridges and tunnels restrict trucks based on weight. If you are transporting HAZMAT material, please specify material type. If you do not specify HAZMAT restrictions and weight restrictions, none will be applied.&lt;/p&gt;

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.OriginAndDestinationPairApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: authorizer
ApiKeyAuth authorizer = (ApiKeyAuth) defaultClient.getAuthentication("authorizer");
authorizer.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//authorizer.setApiKeyPrefix("Token");

OriginAndDestinationPairApi apiInstance = new OriginAndDestinationPairApi();
HereRequestBody body = new HereRequestBody(); // HereRequestBody | 
try {
    HereResponse result = apiInstance.herePost(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OriginAndDestinationPairApi#herePost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HereRequestBody**](HereRequestBody.md)|  | [optional]

### Return type

[**HereResponse**](HereResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

