# Truck

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**truckType** | [**TruckTypeEnum**](#TruckTypeEnum) | Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks. |  [optional]
**trailersCount** | [**BigDecimal**](BigDecimal.md) | Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4. |  [optional]
**shippedHazardousGoods** | [**ShippedHazardousGoodsEnum**](#ShippedHazardousGoodsEnum) | List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt; |  [optional]
**limitedWeight** | [**BigDecimal**](BigDecimal.md) | Vehicle weight including trailers and shipped goods, in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight. |  [optional]
**weightPerAxle** | [**BigDecimal**](BigDecimal.md) | Vehicle weight per axle in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight. |  [optional]
**height** | [**BigDecimal**](BigDecimal.md) | Vehicle height in feet. The provided value must be between 0 and 50. &lt;br&gt; If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight. |  [optional]
**width** | [**BigDecimal**](BigDecimal.md) | Vehicle width in feet. The provided value must be between 0 and 50. |  [optional]
**length** | [**BigDecimal**](BigDecimal.md) | Vehicle length in feet. The provided value must be between 0 and 300. |  [optional]
**tunnelCategory** | [**TunnelCategoryEnum**](#TunnelCategoryEnum) | Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category. |  [optional]
**truckRestrictionPenalty** | [**TruckRestrictionPenaltyEnum**](#TruckRestrictionPenaltyEnum) | pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt; |  [optional]

<a name="TruckTypeEnum"></a>
## Enum: TruckTypeEnum
Name | Value
---- | -----
TRUCK | &quot;truck&quot;
TRACTORTRUCK | &quot;tractorTruck&quot;

<a name="ShippedHazardousGoodsEnum"></a>
## Enum: ShippedHazardousGoodsEnum
Name | Value
---- | -----
EXPLOSIVE | &quot;explosive&quot;
GAS | &quot;gas&quot;
FLAMMABLE | &quot;flammable&quot;
COMBUSTIBLE | &quot;combustible&quot;
ORGANIC | &quot;organic&quot;
POISON | &quot;poison&quot;
RADIOACTIVE | &quot;radioActive&quot;
CORROSIVE | &quot;corrosive&quot;
MISCELLANEOUS | &quot;miscellaneous&quot;

<a name="TunnelCategoryEnum"></a>
## Enum: TunnelCategoryEnum
Name | Value
---- | -----
B | &quot;B&quot;
C | &quot;C&quot;
D | &quot;D&quot;
E | &quot;E&quot;

<a name="TruckRestrictionPenaltyEnum"></a>
## Enum: TruckRestrictionPenaltyEnum
Name | Value
---- | -----
STRICT | &quot;strict&quot;
SOFT | &quot;soft&quot;
