/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
/**
 * &lt;p&gt;Costs object summarizes the toll cost and the fuel cost for the route.The fuel costs calculated from fuel efficiency (city fuel effiency and highway fuel efficiency) and the speeds on each leg of the route.&lt;/p&gt;&lt;p&gt;The tolls are added for all the tolls on the route for each payment type. If a payment type cannot be using on all the toll points on the route, the toll cost is returned as false. Else, the sum of tolls for the payment type is returned.&lt;/p&gt;&lt;p&gt;The tolls are returned for the following payment types:&lt;/p&gt;&lt;ul&gt; &lt;li&gt;Cash&lt;/li&gt;&lt;li&gt;Transponder&lt;/li&gt;&lt;li&gt;License Plate&lt;/li&gt;&lt;li&gt;Credit card&lt;/li&gt;&lt;li&gt;Prepaid pass&lt;/li&gt;&lt;/ul&gt;
 */
@Schema(description = "<p>Costs object summarizes the toll cost and the fuel cost for the route.The fuel costs calculated from fuel efficiency (city fuel effiency and highway fuel efficiency) and the speeds on each leg of the route.</p><p>The tolls are added for all the tolls on the route for each payment type. If a payment type cannot be using on all the toll points on the route, the toll cost is returned as false. Else, the sum of tolls for the payment type is returned.</p><p>The tolls are returned for the following payment types:</p><ul> <li>Cash</li><li>Transponder</li><li>License Plate</li><li>Credit card</li><li>Prepaid pass</li></ul>")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class Cost {
  @SerializedName("fuel")
  private BigDecimal fuel = null;

  @SerializedName("otherCost")
  private BigDecimal otherCost = null;

  @SerializedName("tag")
  private BigDecimal tag = null;

  @SerializedName("cash")
  private BigDecimal cash = null;

  @SerializedName("licensePlate")
  private BigDecimal licensePlate = null;

  @SerializedName("creditCard")
  private BigDecimal creditCard = null;

  @SerializedName("prepaidCard")
  private BigDecimal prepaidCard = null;

  public Cost fuel(BigDecimal fuel) {
    this.fuel = fuel;
    return this;
  }

   /**
   * Get fuel
   * @return fuel
  **/
  @Schema(description = "")
  public BigDecimal getFuel() {
    return fuel;
  }

  public void setFuel(BigDecimal fuel) {
    this.fuel = fuel;
  }

  public Cost otherCost(BigDecimal otherCost) {
    this.otherCost = otherCost;
    return this;
  }

   /**
   * Get otherCost
   * @return otherCost
  **/
  @Schema(description = "")
  public BigDecimal getOtherCost() {
    return otherCost;
  }

  public void setOtherCost(BigDecimal otherCost) {
    this.otherCost = otherCost;
  }

  public Cost tag(BigDecimal tag) {
    this.tag = tag;
    return this;
  }

   /**
   * Get tag
   * @return tag
  **/
  @Schema(description = "")
  public BigDecimal getTag() {
    return tag;
  }

  public void setTag(BigDecimal tag) {
    this.tag = tag;
  }

  public Cost cash(BigDecimal cash) {
    this.cash = cash;
    return this;
  }

   /**
   * Get cash
   * @return cash
  **/
  @Schema(description = "")
  public BigDecimal getCash() {
    return cash;
  }

  public void setCash(BigDecimal cash) {
    this.cash = cash;
  }

  public Cost licensePlate(BigDecimal licensePlate) {
    this.licensePlate = licensePlate;
    return this;
  }

   /**
   * Get licensePlate
   * @return licensePlate
  **/
  @Schema(description = "")
  public BigDecimal getLicensePlate() {
    return licensePlate;
  }

  public void setLicensePlate(BigDecimal licensePlate) {
    this.licensePlate = licensePlate;
  }

  public Cost creditCard(BigDecimal creditCard) {
    this.creditCard = creditCard;
    return this;
  }

   /**
   * Get creditCard
   * @return creditCard
  **/
  @Schema(description = "")
  public BigDecimal getCreditCard() {
    return creditCard;
  }

  public void setCreditCard(BigDecimal creditCard) {
    this.creditCard = creditCard;
  }

  public Cost prepaidCard(BigDecimal prepaidCard) {
    this.prepaidCard = prepaidCard;
    return this;
  }

   /**
   * Get prepaidCard
   * @return prepaidCard
  **/
  @Schema(description = "")
  public BigDecimal getPrepaidCard() {
    return prepaidCard;
  }

  public void setPrepaidCard(BigDecimal prepaidCard) {
    this.prepaidCard = prepaidCard;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Cost cost = (Cost) o;
    return Objects.equals(this.fuel, cost.fuel) &&
        Objects.equals(this.otherCost, cost.otherCost) &&
        Objects.equals(this.tag, cost.tag) &&
        Objects.equals(this.cash, cost.cash) &&
        Objects.equals(this.licensePlate, cost.licensePlate) &&
        Objects.equals(this.creditCard, cost.creditCard) &&
        Objects.equals(this.prepaidCard, cost.prepaidCard);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fuel, otherCost, tag, cash, licensePlate, creditCard, prepaidCard);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Cost {\n");
    
    sb.append("    fuel: ").append(toIndentedString(fuel)).append("\n");
    sb.append("    otherCost: ").append(toIndentedString(otherCost)).append("\n");
    sb.append("    tag: ").append(toIndentedString(tag)).append("\n");
    sb.append("    cash: ").append(toIndentedString(cash)).append("\n");
    sb.append("    licensePlate: ").append(toIndentedString(licensePlate)).append("\n");
    sb.append("    creditCard: ").append(toIndentedString(creditCard)).append("\n");
    sb.append("    prepaidCard: ").append(toIndentedString(prepaidCard)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
