/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
/**
 * &lt;p&gt;You need to specify parameters in &lt;code&gt;driver&lt;/code&gt; object to estimate driver wages. You can also specify your &lt;a href&#x3D;\&quot;https://en.wikipedia.org/wiki/Value_of_time\&quot;&gt;value of time&lt;/a&gt;. For example, if you are willing to spend $2.00 to save 15 minutes (but not a penny more) for a particular trip, your value of time is $2.00* (60/15) &#x3D; $8.00 per hour.&lt;/p&gt;
 */
@Schema(description = "<p>You need to specify parameters in <code>driver</code> object to estimate driver wages. You can also specify your <a href=\"https://en.wikipedia.org/wiki/Value_of_time\">value of time</a>. For example, if you are willing to spend $2.00 to save 15 minutes (but not a penny more) for a particular trip, your value of time is $2.00* (60/15) = $8.00 per hour.</p>")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class Driver {
  @SerializedName("wage")
  private BigDecimal wage = 30;

  @SerializedName("rounding")
  private BigDecimal rounding = 30;

  @SerializedName("valueOfTime")
  private BigDecimal valueOfTime = 0;

  public Driver wage(BigDecimal wage) {
    this.wage = wage;
    return this;
  }

   /**
   * Driver wage per hour
   * @return wage
  **/
  @Schema(description = "Driver wage per hour")
  public BigDecimal getWage() {
    return wage;
  }

  public void setWage(BigDecimal wage) {
    this.wage = wage;
  }

  public Driver rounding(BigDecimal rounding) {
    this.rounding = rounding;
    return this;
  }

   /**
   * How is the driver time is rounded (to 30 minutes, an hour, etc.)?
   * @return rounding
  **/
  @Schema(description = "How is the driver time is rounded (to 30 minutes, an hour, etc.)?")
  public BigDecimal getRounding() {
    return rounding;
  }

  public void setRounding(BigDecimal rounding) {
    this.rounding = rounding;
  }

  public Driver valueOfTime(BigDecimal valueOfTime) {
    this.valueOfTime = valueOfTime;
    return this;
  }

   /**
   * If driver wages are specified, do not add value of time. If value of time is specified, it is assumed you are the driver and not being paid for the time. Driver wage calculations will not be returned.
   * @return valueOfTime
  **/
  @Schema(description = "If driver wages are specified, do not add value of time. If value of time is specified, it is assumed you are the driver and not being paid for the time. Driver wage calculations will not be returned.")
  public BigDecimal getValueOfTime() {
    return valueOfTime;
  }

  public void setValueOfTime(BigDecimal valueOfTime) {
    this.valueOfTime = valueOfTime;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Driver driver = (Driver) o;
    return Objects.equals(this.wage, driver.wage) &&
        Objects.equals(this.rounding, driver.rounding) &&
        Objects.equals(this.valueOfTime, driver.valueOfTime);
  }

  @Override
  public int hashCode() {
    return Objects.hash(wage, rounding, valueOfTime);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Driver {\n");
    
    sb.append("    wage: ").append(toIndentedString(wage)).append("\n");
    sb.append("    rounding: ").append(toIndentedString(rounding)).append("\n");
    sb.append("    valueOfTime: ").append(toIndentedString(valueOfTime)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
