/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.Location;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
/**
 * GmapRequestBody
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class GmapRequestBody {
  @SerializedName("from")
  private AllOfGmapRequestBodyFrom from = null;

  @SerializedName("to")
  private AllOfGmapRequestBodyTo to = null;

  @SerializedName("waypoints")
  private List<Location> waypoints = null;

  @SerializedName("vehicleType")
  private AllOfGmapRequestBodyVehicleType vehicleType = null;

  @SerializedName("departure_time")
  private OneOfGmapRequestBodyDepartureTime departureTime = null;

  @SerializedName("fuelPrice")
  private BigDecimal fuelPrice = 3;

  /**
   * Gets or Sets fuelPriceCurrency
   */
  @JsonAdapter(FuelPriceCurrencyEnum.Adapter.class)
  public enum FuelPriceCurrencyEnum {
    USD("USD"),
    CAD("CAD"),
    MXN("MXN"),
    INR("INR");

    private String value;

    FuelPriceCurrencyEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static FuelPriceCurrencyEnum fromValue(String text) {
      for (FuelPriceCurrencyEnum b : FuelPriceCurrencyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<FuelPriceCurrencyEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final FuelPriceCurrencyEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public FuelPriceCurrencyEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return FuelPriceCurrencyEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("fuelPriceCurrency")
  private FuelPriceCurrencyEnum fuelPriceCurrency = FuelPriceCurrencyEnum.USD;

  @SerializedName("fuelEfficiency")
  private AllOfGmapRequestBodyFuelEfficiency fuelEfficiency = null;

  @SerializedName("driver")
  private AllOfGmapRequestBodyDriver driver = null;

  @SerializedName("hos")
  private AllOfGmapRequestBodyHos hos = null;

  public GmapRequestBody from(AllOfGmapRequestBodyFrom from) {
    this.from = from;
    return this;
  }

   /**
   * Get from
   * @return from
  **/
  @Schema(example = "{\"address\":\"Main str, Dallas, TX\"}", required = true, description = "")
  public AllOfGmapRequestBodyFrom getFrom() {
    return from;
  }

  public void setFrom(AllOfGmapRequestBodyFrom from) {
    this.from = from;
  }

  public GmapRequestBody to(AllOfGmapRequestBodyTo to) {
    this.to = to;
    return this;
  }

   /**
   * Get to
   * @return to
  **/
  @Schema(example = "{\"address\":\"Addison, TX\"}", required = true, description = "")
  public AllOfGmapRequestBodyTo getTo() {
    return to;
  }

  public void setTo(AllOfGmapRequestBodyTo to) {
    this.to = to;
  }

  public GmapRequestBody waypoints(List<Location> waypoints) {
    this.waypoints = waypoints;
    return this;
  }

  public GmapRequestBody addWaypointsItem(Location waypointsItem) {
    if (this.waypoints == null) {
      this.waypoints = new ArrayList<Location>();
    }
    this.waypoints.add(waypointsItem);
    return this;
  }

   /**
   * Get waypoints
   * @return waypoints
  **/
  @Schema(example = "[{\"address\":\"Plano, TX\"},{\"address\":\"Allen, TX\"}]", description = "")
  public List<Location> getWaypoints() {
    return waypoints;
  }

  public void setWaypoints(List<Location> waypoints) {
    this.waypoints = waypoints;
  }

  public GmapRequestBody vehicleType(AllOfGmapRequestBodyVehicleType vehicleType) {
    this.vehicleType = vehicleType;
    return this;
  }

   /**
   * Get vehicleType
   * @return vehicleType
  **/
  @Schema(example = "2AxlesAuto", description = "")
  public AllOfGmapRequestBodyVehicleType getVehicleType() {
    return vehicleType;
  }

  public void setVehicleType(AllOfGmapRequestBodyVehicleType vehicleType) {
    this.vehicleType = vehicleType;
  }

  public GmapRequestBody departureTime(OneOfGmapRequestBodyDepartureTime departureTime) {
    this.departureTime = departureTime;
    return this;
  }

   /**
   * Get departureTime
   * @return departureTime
  **/
  @Schema(example = "1551541566", description = "")
  public OneOfGmapRequestBodyDepartureTime getDepartureTime() {
    return departureTime;
  }

  public void setDepartureTime(OneOfGmapRequestBodyDepartureTime departureTime) {
    this.departureTime = departureTime;
  }

  public GmapRequestBody fuelPrice(BigDecimal fuelPrice) {
    this.fuelPrice = fuelPrice;
    return this;
  }

   /**
   * Get fuelPrice
   * @return fuelPrice
  **/
  @Schema(example = "2.79", description = "")
  public BigDecimal getFuelPrice() {
    return fuelPrice;
  }

  public void setFuelPrice(BigDecimal fuelPrice) {
    this.fuelPrice = fuelPrice;
  }

  public GmapRequestBody fuelPriceCurrency(FuelPriceCurrencyEnum fuelPriceCurrency) {
    this.fuelPriceCurrency = fuelPriceCurrency;
    return this;
  }

   /**
   * Get fuelPriceCurrency
   * @return fuelPriceCurrency
  **/
  @Schema(example = "USD", description = "")
  public FuelPriceCurrencyEnum getFuelPriceCurrency() {
    return fuelPriceCurrency;
  }

  public void setFuelPriceCurrency(FuelPriceCurrencyEnum fuelPriceCurrency) {
    this.fuelPriceCurrency = fuelPriceCurrency;
  }

  public GmapRequestBody fuelEfficiency(AllOfGmapRequestBodyFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
    return this;
  }

   /**
   * Get fuelEfficiency
   * @return fuelEfficiency
  **/
  @Schema(example = "{\"city\":24,\"hwy\":30,\"units\":\"mpg\"}", description = "")
  public AllOfGmapRequestBodyFuelEfficiency getFuelEfficiency() {
    return fuelEfficiency;
  }

  public void setFuelEfficiency(AllOfGmapRequestBodyFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
  }

  public GmapRequestBody driver(AllOfGmapRequestBodyDriver driver) {
    this.driver = driver;
    return this;
  }

   /**
   * Get driver
   * @return driver
  **/
  @Schema(example = "{\"wage\":30,\"rounding\":15,\"valueOfTime\":0}", description = "")
  public AllOfGmapRequestBodyDriver getDriver() {
    return driver;
  }

  public void setDriver(AllOfGmapRequestBodyDriver driver) {
    this.driver = driver;
  }

  public GmapRequestBody hos(AllOfGmapRequestBodyHos hos) {
    this.hos = hos;
    return this;
  }

   /**
   * Get hos
   * @return hos
  **/
  @Schema(example = "{\"rule\":60,\"dutyHoursBeforeEndOfWorkDay\":11,\"dutyHoursBeforeRestBreak\":7,\"drivingHoursBeforeEndOfWorkDay\":11,\"timeRemaining\":60}", description = "")
  public AllOfGmapRequestBodyHos getHos() {
    return hos;
  }

  public void setHos(AllOfGmapRequestBodyHos hos) {
    this.hos = hos;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GmapRequestBody gmapRequestBody = (GmapRequestBody) o;
    return Objects.equals(this.from, gmapRequestBody.from) &&
        Objects.equals(this.to, gmapRequestBody.to) &&
        Objects.equals(this.waypoints, gmapRequestBody.waypoints) &&
        Objects.equals(this.vehicleType, gmapRequestBody.vehicleType) &&
        Objects.equals(this.departureTime, gmapRequestBody.departureTime) &&
        Objects.equals(this.fuelPrice, gmapRequestBody.fuelPrice) &&
        Objects.equals(this.fuelPriceCurrency, gmapRequestBody.fuelPriceCurrency) &&
        Objects.equals(this.fuelEfficiency, gmapRequestBody.fuelEfficiency) &&
        Objects.equals(this.driver, gmapRequestBody.driver) &&
        Objects.equals(this.hos, gmapRequestBody.hos);
  }

  @Override
  public int hashCode() {
    return Objects.hash(from, to, waypoints, vehicleType, departureTime, fuelPrice, fuelPriceCurrency, fuelEfficiency, driver, hos);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GmapRequestBody {\n");
    
    sb.append("    from: ").append(toIndentedString(from)).append("\n");
    sb.append("    to: ").append(toIndentedString(to)).append("\n");
    sb.append("    waypoints: ").append(toIndentedString(waypoints)).append("\n");
    sb.append("    vehicleType: ").append(toIndentedString(vehicleType)).append("\n");
    sb.append("    departureTime: ").append(toIndentedString(departureTime)).append("\n");
    sb.append("    fuelPrice: ").append(toIndentedString(fuelPrice)).append("\n");
    sb.append("    fuelPriceCurrency: ").append(toIndentedString(fuelPriceCurrency)).append("\n");
    sb.append("    fuelEfficiency: ").append(toIndentedString(fuelEfficiency)).append("\n");
    sb.append("    driver: ").append(toIndentedString(driver)).append("\n");
    sb.append("    hos: ").append(toIndentedString(hos)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
