/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.Location;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
/**
 * HereRequestBody
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class HereRequestBody {
  @SerializedName("from")
  private AllOfHereRequestBodyFrom from = null;

  @SerializedName("to")
  private AllOfHereRequestBodyTo to = null;

  @SerializedName("waypoints")
  private List<Location> waypoints = null;

  @SerializedName("vehicleType")
  private AllOfHereRequestBodyVehicleType vehicleType = null;

  @SerializedName("departure_time")
  private OneOfHereRequestBodyDepartureTime departureTime = null;

  @SerializedName("fuelPrice")
  private BigDecimal fuelPrice = 3;

  /**
   * Gets or Sets fuelPriceCurrency
   */
  @JsonAdapter(FuelPriceCurrencyEnum.Adapter.class)
  public enum FuelPriceCurrencyEnum {
    USD("USD"),
    CAD("CAD"),
    MXN("MXN"),
    INR("INR");

    private String value;

    FuelPriceCurrencyEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static FuelPriceCurrencyEnum fromValue(String text) {
      for (FuelPriceCurrencyEnum b : FuelPriceCurrencyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<FuelPriceCurrencyEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final FuelPriceCurrencyEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public FuelPriceCurrencyEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return FuelPriceCurrencyEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("fuelPriceCurrency")
  private FuelPriceCurrencyEnum fuelPriceCurrency = FuelPriceCurrencyEnum.USD;

  @SerializedName("fuelEfficiency")
  private AllOfHereRequestBodyFuelEfficiency fuelEfficiency = null;

  @SerializedName("truck")
  private AllOfHereRequestBodyTruck truck = null;

  @SerializedName("driver")
  private AllOfHereRequestBodyDriver driver = null;

  @SerializedName("state_mileage")
  private Boolean stateMileage = null;

  @SerializedName("hos")
  private AllOfHereRequestBodyHos hos = null;

  public HereRequestBody from(AllOfHereRequestBodyFrom from) {
    this.from = from;
    return this;
  }

   /**
   * Get from
   * @return from
  **/
  @Schema(example = "{\"address\":\"Main str, Dallas, TX\"}", required = true, description = "")
  public AllOfHereRequestBodyFrom getFrom() {
    return from;
  }

  public void setFrom(AllOfHereRequestBodyFrom from) {
    this.from = from;
  }

  public HereRequestBody to(AllOfHereRequestBodyTo to) {
    this.to = to;
    return this;
  }

   /**
   * Get to
   * @return to
  **/
  @Schema(example = "{\"address\":\"Addison, TX\"}", required = true, description = "")
  public AllOfHereRequestBodyTo getTo() {
    return to;
  }

  public void setTo(AllOfHereRequestBodyTo to) {
    this.to = to;
  }

  public HereRequestBody waypoints(List<Location> waypoints) {
    this.waypoints = waypoints;
    return this;
  }

  public HereRequestBody addWaypointsItem(Location waypointsItem) {
    if (this.waypoints == null) {
      this.waypoints = new ArrayList<Location>();
    }
    this.waypoints.add(waypointsItem);
    return this;
  }

   /**
   * Get waypoints
   * @return waypoints
  **/
  @Schema(example = "[{\"address\":\"Plano, TX\"},{\"address\":\"Allen, TX\"}]", description = "")
  public List<Location> getWaypoints() {
    return waypoints;
  }

  public void setWaypoints(List<Location> waypoints) {
    this.waypoints = waypoints;
  }

  public HereRequestBody vehicleType(AllOfHereRequestBodyVehicleType vehicleType) {
    this.vehicleType = vehicleType;
    return this;
  }

   /**
   * Get vehicleType
   * @return vehicleType
  **/
  @Schema(example = "2AxlesAuto", description = "")
  public AllOfHereRequestBodyVehicleType getVehicleType() {
    return vehicleType;
  }

  public void setVehicleType(AllOfHereRequestBodyVehicleType vehicleType) {
    this.vehicleType = vehicleType;
  }

  public HereRequestBody departureTime(OneOfHereRequestBodyDepartureTime departureTime) {
    this.departureTime = departureTime;
    return this;
  }

   /**
   * Get departureTime
   * @return departureTime
  **/
  @Schema(example = "1551541566", description = "")
  public OneOfHereRequestBodyDepartureTime getDepartureTime() {
    return departureTime;
  }

  public void setDepartureTime(OneOfHereRequestBodyDepartureTime departureTime) {
    this.departureTime = departureTime;
  }

  public HereRequestBody fuelPrice(BigDecimal fuelPrice) {
    this.fuelPrice = fuelPrice;
    return this;
  }

   /**
   * Get fuelPrice
   * @return fuelPrice
  **/
  @Schema(example = "2.79", description = "")
  public BigDecimal getFuelPrice() {
    return fuelPrice;
  }

  public void setFuelPrice(BigDecimal fuelPrice) {
    this.fuelPrice = fuelPrice;
  }

  public HereRequestBody fuelPriceCurrency(FuelPriceCurrencyEnum fuelPriceCurrency) {
    this.fuelPriceCurrency = fuelPriceCurrency;
    return this;
  }

   /**
   * Get fuelPriceCurrency
   * @return fuelPriceCurrency
  **/
  @Schema(example = "USD", description = "")
  public FuelPriceCurrencyEnum getFuelPriceCurrency() {
    return fuelPriceCurrency;
  }

  public void setFuelPriceCurrency(FuelPriceCurrencyEnum fuelPriceCurrency) {
    this.fuelPriceCurrency = fuelPriceCurrency;
  }

  public HereRequestBody fuelEfficiency(AllOfHereRequestBodyFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
    return this;
  }

   /**
   * Get fuelEfficiency
   * @return fuelEfficiency
  **/
  @Schema(example = "{\"city\":24,\"hwy\":30,\"units\":\"mpg\"}", description = "")
  public AllOfHereRequestBodyFuelEfficiency getFuelEfficiency() {
    return fuelEfficiency;
  }

  public void setFuelEfficiency(AllOfHereRequestBodyFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
  }

  public HereRequestBody truck(AllOfHereRequestBodyTruck truck) {
    this.truck = truck;
    return this;
  }

   /**
   * Truck routing only
   * @return truck
  **/
  @Schema(example = "{\"limitedWeight\":44000}", description = "Truck routing only")
  public AllOfHereRequestBodyTruck getTruck() {
    return truck;
  }

  public void setTruck(AllOfHereRequestBodyTruck truck) {
    this.truck = truck;
  }

  public HereRequestBody driver(AllOfHereRequestBodyDriver driver) {
    this.driver = driver;
    return this;
  }

   /**
   * Driver wage or Value of Time
   * @return driver
  **/
  @Schema(example = "{\"wage\":30,\"rounding\":15,\"valueOfTime\":0}", description = "Driver wage or Value of Time")
  public AllOfHereRequestBodyDriver getDriver() {
    return driver;
  }

  public void setDriver(AllOfHereRequestBodyDriver driver) {
    this.driver = driver;
  }

  public HereRequestBody stateMileage(Boolean stateMileage) {
    this.stateMileage = stateMileage;
    return this;
  }

   /**
   * Get stateMileage
   * @return stateMileage
  **/
  @Schema(example = "true", description = "")
  public Boolean isStateMileage() {
    return stateMileage;
  }

  public void setStateMileage(Boolean stateMileage) {
    this.stateMileage = stateMileage;
  }

  public HereRequestBody hos(AllOfHereRequestBodyHos hos) {
    this.hos = hos;
    return this;
  }

   /**
   * Get hos
   * @return hos
  **/
  @Schema(example = "{\"rule\":60,\"dutyHoursBeforeEndOfWorkDay\":11,\"dutyHoursBeforeRestBreak\":7,\"drivingHoursBeforeEndOfWorkDay\":11,\"timeRemaining\":60}", description = "")
  public AllOfHereRequestBodyHos getHos() {
    return hos;
  }

  public void setHos(AllOfHereRequestBodyHos hos) {
    this.hos = hos;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HereRequestBody hereRequestBody = (HereRequestBody) o;
    return Objects.equals(this.from, hereRequestBody.from) &&
        Objects.equals(this.to, hereRequestBody.to) &&
        Objects.equals(this.waypoints, hereRequestBody.waypoints) &&
        Objects.equals(this.vehicleType, hereRequestBody.vehicleType) &&
        Objects.equals(this.departureTime, hereRequestBody.departureTime) &&
        Objects.equals(this.fuelPrice, hereRequestBody.fuelPrice) &&
        Objects.equals(this.fuelPriceCurrency, hereRequestBody.fuelPriceCurrency) &&
        Objects.equals(this.fuelEfficiency, hereRequestBody.fuelEfficiency) &&
        Objects.equals(this.truck, hereRequestBody.truck) &&
        Objects.equals(this.driver, hereRequestBody.driver) &&
        Objects.equals(this.stateMileage, hereRequestBody.stateMileage) &&
        Objects.equals(this.hos, hereRequestBody.hos);
  }

  @Override
  public int hashCode() {
    return Objects.hash(from, to, waypoints, vehicleType, departureTime, fuelPrice, fuelPriceCurrency, fuelEfficiency, truck, driver, stateMileage, hos);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HereRequestBody {\n");
    
    sb.append("    from: ").append(toIndentedString(from)).append("\n");
    sb.append("    to: ").append(toIndentedString(to)).append("\n");
    sb.append("    waypoints: ").append(toIndentedString(waypoints)).append("\n");
    sb.append("    vehicleType: ").append(toIndentedString(vehicleType)).append("\n");
    sb.append("    departureTime: ").append(toIndentedString(departureTime)).append("\n");
    sb.append("    fuelPrice: ").append(toIndentedString(fuelPrice)).append("\n");
    sb.append("    fuelPriceCurrency: ").append(toIndentedString(fuelPriceCurrency)).append("\n");
    sb.append("    fuelEfficiency: ").append(toIndentedString(fuelEfficiency)).append("\n");
    sb.append("    truck: ").append(toIndentedString(truck)).append("\n");
    sb.append("    driver: ").append(toIndentedString(driver)).append("\n");
    sb.append("    stateMileage: ").append(toIndentedString(stateMileage)).append("\n");
    sb.append("    hos: ").append(toIndentedString(hos)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
