/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.HereResponseSummaryFuelPrice;
import io.swagger.client.model.Rates;
import io.swagger.client.model.Route;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
/**
 * HereResponseSummary
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class HereResponseSummary {
  @SerializedName("route")
  private List<Route> route = null;

  @SerializedName("rates")
  private Rates rates = null;

  @SerializedName("departure_time")
  private BigDecimal departureTime = null;

  @SerializedName("fuelPrice")
  private HereResponseSummaryFuelPrice fuelPrice = null;

  @SerializedName("fuelEfficiency")
  private AllOfHereResponseSummaryFuelEfficiency fuelEfficiency = null;

  @SerializedName("vehicleType")
  private AllOfHereResponseSummaryVehicleType vehicleType = null;

  @SerializedName("share")
  private Object share = null;

  public HereResponseSummary route(List<Route> route) {
    this.route = route;
    return this;
  }

  public HereResponseSummary addRouteItem(Route routeItem) {
    if (this.route == null) {
      this.route = new ArrayList<Route>();
    }
    this.route.add(routeItem);
    return this;
  }

   /**
   * Get route
   * @return route
  **/
  @Schema(example = "[{\"location\":{\"lat\":32.78165,\"lng\":-96.79448},\"address\":\"Main St, Dallas, TX 75201, United States\"},{\"location\":{\"lat\":33.02079,\"lng\":-96.69925},\"address\":\"Plano, TX, United States\"},{\"location\":{\"lat\":33.10144,\"lng\":-96.67449},\"address\":\"Allen, TX, United States\"},{\"location\":{\"lat\":32.95398,\"lng\":-96.81769},\"address\":\"Addison, TX, United States\"}]", description = "")
  public List<Route> getRoute() {
    return route;
  }

  public void setRoute(List<Route> route) {
    this.route = route;
  }

  public HereResponseSummary rates(Rates rates) {
    this.rates = rates;
    return this;
  }

   /**
   * Get rates
   * @return rates
  **/
  @Schema(description = "")
  public Rates getRates() {
    return rates;
  }

  public void setRates(Rates rates) {
    this.rates = rates;
  }

  public HereResponseSummary departureTime(BigDecimal departureTime) {
    this.departureTime = departureTime;
    return this;
  }

   /**
   * Get departureTime
   * @return departureTime
  **/
  @Schema(example = "1551541566", description = "")
  public BigDecimal getDepartureTime() {
    return departureTime;
  }

  public void setDepartureTime(BigDecimal departureTime) {
    this.departureTime = departureTime;
  }

  public HereResponseSummary fuelPrice(HereResponseSummaryFuelPrice fuelPrice) {
    this.fuelPrice = fuelPrice;
    return this;
  }

   /**
   * Get fuelPrice
   * @return fuelPrice
  **/
  @Schema(description = "")
  public HereResponseSummaryFuelPrice getFuelPrice() {
    return fuelPrice;
  }

  public void setFuelPrice(HereResponseSummaryFuelPrice fuelPrice) {
    this.fuelPrice = fuelPrice;
  }

  public HereResponseSummary fuelEfficiency(AllOfHereResponseSummaryFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
    return this;
  }

   /**
   * City fuel efficiency and highway fuel efficiency from request or the default values. Returns fuel efficiency units
   * @return fuelEfficiency
  **/
  @Schema(example = "{\"city\":24,\"hwy\":30,\"units\":\"mpg\"}", description = "City fuel efficiency and highway fuel efficiency from request or the default values. Returns fuel efficiency units")
  public AllOfHereResponseSummaryFuelEfficiency getFuelEfficiency() {
    return fuelEfficiency;
  }

  public void setFuelEfficiency(AllOfHereResponseSummaryFuelEfficiency fuelEfficiency) {
    this.fuelEfficiency = fuelEfficiency;
  }

  public HereResponseSummary vehicleType(AllOfHereResponseSummaryVehicleType vehicleType) {
    this.vehicleType = vehicleType;
    return this;
  }

   /**
   * Get vehicleType
   * @return vehicleType
  **/
  @Schema(example = "2AxlesAuto", description = "")
  public AllOfHereResponseSummaryVehicleType getVehicleType() {
    return vehicleType;
  }

  public void setVehicleType(AllOfHereResponseSummaryVehicleType vehicleType) {
    this.vehicleType = vehicleType;
  }

  public HereResponseSummary share(Object share) {
    this.share = share;
    return this;
  }

   /**
   * Get share
   * @return share
  **/
  @Schema(description = "")
  public Object getShare() {
    return share;
  }

  public void setShare(Object share) {
    this.share = share;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HereResponseSummary hereResponseSummary = (HereResponseSummary) o;
    return Objects.equals(this.route, hereResponseSummary.route) &&
        Objects.equals(this.rates, hereResponseSummary.rates) &&
        Objects.equals(this.departureTime, hereResponseSummary.departureTime) &&
        Objects.equals(this.fuelPrice, hereResponseSummary.fuelPrice) &&
        Objects.equals(this.fuelEfficiency, hereResponseSummary.fuelEfficiency) &&
        Objects.equals(this.vehicleType, hereResponseSummary.vehicleType) &&
        Objects.equals(this.share, hereResponseSummary.share);
  }

  @Override
  public int hashCode() {
    return Objects.hash(route, rates, departureTime, fuelPrice, fuelEfficiency, vehicleType, share);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HereResponseSummary {\n");
    
    sb.append("    route: ").append(toIndentedString(route)).append("\n");
    sb.append("    rates: ").append(toIndentedString(rates)).append("\n");
    sb.append("    departureTime: ").append(toIndentedString(departureTime)).append("\n");
    sb.append("    fuelPrice: ").append(toIndentedString(fuelPrice)).append("\n");
    sb.append("    fuelEfficiency: ").append(toIndentedString(fuelEfficiency)).append("\n");
    sb.append("    vehicleType: ").append(toIndentedString(vehicleType)).append("\n");
    sb.append("    share: ").append(toIndentedString(share)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
