/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.HosData;
import io.swagger.client.model.HosResponseSummary;
import io.swagger.client.model.Stop;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * HosResponse
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class HosResponse {
  @SerializedName("summary")
  private HosResponseSummary summary = null;

  @SerializedName("break_points")
  private List<List<String>> breakPoints = null;

  @SerializedName("stops")
  private List<Stop> stops = null;

  @SerializedName("data")
  private List<HosData> data = null;

  public HosResponse summary(HosResponseSummary summary) {
    this.summary = summary;
    return this;
  }

   /**
   * Get summary
   * @return summary
  **/
  @Schema(description = "")
  public HosResponseSummary getSummary() {
    return summary;
  }

  public void setSummary(HosResponseSummary summary) {
    this.summary = summary;
  }

  public HosResponse breakPoints(List<List<String>> breakPoints) {
    this.breakPoints = breakPoints;
    return this;
  }

  public HosResponse addBreakPointsItem(List<String> breakPointsItem) {
    if (this.breakPoints == null) {
      this.breakPoints = new ArrayList<List<String>>();
    }
    this.breakPoints.add(breakPointsItem);
    return this;
  }

   /**
   * Get breakPoints
   * @return breakPoints
  **/
  @Schema(example = "[[33.02079,-96.69925]]", description = "")
  public List<List<String>> getBreakPoints() {
    return breakPoints;
  }

  public void setBreakPoints(List<List<String>> breakPoints) {
    this.breakPoints = breakPoints;
  }

  public HosResponse stops(List<Stop> stops) {
    this.stops = stops;
    return this;
  }

  public HosResponse addStopsItem(Stop stopsItem) {
    if (this.stops == null) {
      this.stops = new ArrayList<Stop>();
    }
    this.stops.add(stopsItem);
    return this;
  }

   /**
   * Get stops
   * @return stops
  **/
  @Schema(example = "[{\"additionalServices\":\"\",\"amenities\":\"Parking, Truck\",\"businessesName\":\"Rodeway Inn\",\"city\":\"Sandusky\",\"contactName\":\"\",\"fax\":\"(419) 626-4118\",\"fuelLanes\":-1,\"highway\":\"\",\"latitude\":41.4465332,\"longitude\":-82.69683075,\"parkingSpots\":\"\",\"paymentMethods\":\"\",\"phone1\":\"(419) 626-6852\",\"phone2\":\"\",\"phone3\":\"\",\"postalCode\":\"\",\"restIndex\":\"1\",\"showers\":-1,\"state\":\"OH\",\"stopId\":5254,\"streetAddress\":\"1021 Cleveland Rd.\",\"truckServiceBays\":-1,\"type\":\"motels\",\"webAddress\":\"\"}]", description = "")
  public List<Stop> getStops() {
    return stops;
  }

  public void setStops(List<Stop> stops) {
    this.stops = stops;
  }

  public HosResponse data(List<HosData> data) {
    this.data = data;
    return this;
  }

  public HosResponse addDataItem(HosData dataItem) {
    if (this.data == null) {
      this.data = new ArrayList<HosData>();
    }
    this.data.add(dataItem);
    return this;
  }

   /**
   * Get data
   * @return data
  **/
  @Schema(example = "[{\"instruction\":\"Start from Plano, TX USA\"},{\"instruction\":\"Drive\",\"duration\":{\"text\":\"53 m\",\"value\":3216},\"distance\":{\"text\":26,\"metric\":43,\"value\":42514}},{\"instruction\":\"Break\",\"duration\":{\"text\":\"30 m\",\"value\":1800}}]", description = "")
  public List<HosData> getData() {
    return data;
  }

  public void setData(List<HosData> data) {
    this.data = data;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HosResponse hosResponse = (HosResponse) o;
    return Objects.equals(this.summary, hosResponse.summary) &&
        Objects.equals(this.breakPoints, hosResponse.breakPoints) &&
        Objects.equals(this.stops, hosResponse.stops) &&
        Objects.equals(this.data, hosResponse.data);
  }

  @Override
  public int hashCode() {
    return Objects.hash(summary, breakPoints, stops, data);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HosResponse {\n");
    
    sb.append("    summary: ").append(toIndentedString(summary)).append("\n");
    sb.append("    breakPoints: ").append(toIndentedString(breakPoints)).append("\n");
    sb.append("    stops: ").append(toIndentedString(stops)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
