/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
/**
 * Tolls object contains tolls for all the toll locations on the route. For each toll location
 */
@Schema(description = "Tolls object contains tolls for all the toll locations on the route. For each toll location")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class Toll {
  @SerializedName("type")
  private String type = null;

  @SerializedName("tagCost")
  private BigDecimal tagCost = null;

  @SerializedName("cashCost")
  private BigDecimal cashCost = null;

  @SerializedName("licensePlateCost")
  private BigDecimal licensePlateCost = null;

  @SerializedName("prepaidCardCost")
  private BigDecimal prepaidCardCost = null;

  @SerializedName("creditCardCost")
  private BigDecimal creditCardCost = null;

  @SerializedName("currency")
  private String currency = null;

  @SerializedName("tagPrimary")
  private List<String> tagPrimary = null;

  @SerializedName("tagSecondary")
  private List<String> tagSecondary = null;

  @SerializedName("licensePlatePrimary")
  private String licensePlatePrimary = null;

  @SerializedName("licensePlateSecondary")
  private String licensePlateSecondary = null;

  @SerializedName("id")
  private BigDecimal id = null;

  @SerializedName("lat")
  private BigDecimal lat = null;

  @SerializedName("lng")
  private BigDecimal lng = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("road")
  private String road = null;

  @SerializedName("state")
  private String state = null;

  public Toll type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Toll type: &lt;br&gt;&lt;code&gt;barrier&lt;/code&gt; (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Texas &lt;/a&gt;), &lt;br&gt;&lt;code&gt;ticketSystem&lt;/code&gt; - ticket system (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Oklahoma&lt;/a&gt;), &lt;br&gt;&lt;code&gt;distBased&lt;/code&gt; – distance based (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\&quot; target&#x3D;\&quot;_blank\&quot;&gt; ETR 407 in Ontario, Canada&lt;/a&gt;).
   * @return type
  **/
  @Schema(description = "Toll type: <br><code>barrier</code> (for example <a href=\"https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\" target=\"_blank\"> toll roads in Texas </a>), <br><code>ticketSystem</code> - ticket system (for example <a href=\"https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\" target=\"_blank\"> toll roads in Oklahoma</a>), <br><code>distBased</code> – distance based (for example <a href=\"https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\" target=\"_blank\"> ETR 407 in Ontario, Canada</a>).")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public Toll tagCost(BigDecimal tagCost) {
    this.tagCost = tagCost;
    return this;
  }

   /**
   * Transponder toll cost &lt;br&gt;For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/new-york/what-is-e-zpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;E-ZPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\&quot; target&#x3D;\&quot;_blank\&quot;&gt;TxTag&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/what-is-sunpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;SunPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ExpressToll&lt;/a&gt;, etc.
   * @return tagCost
  **/
  @Schema(description = "Transponder toll cost <br>For example, <a href=\"https://tollguru.com/toll-info/new-york/what-is-e-zpass\" target=\"_blank\">E-ZPass</a>, <a href=\"https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\" target=\"_blank\">TxTag</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/florida/what-is-sunpass\" target=\"_blank\">SunPass</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\" target=\"_blank\">ExpressToll</a>, etc.")
  public BigDecimal getTagCost() {
    return tagCost;
  }

  public void setTagCost(BigDecimal tagCost) {
    this.tagCost = tagCost;
  }

  public Toll cashCost(BigDecimal cashCost) {
    this.cashCost = cashCost;
    return this;
  }

   /**
   * Cash toll cost
   * @return cashCost
  **/
  @Schema(description = "Cash toll cost")
  public BigDecimal getCashCost() {
    return cashCost;
  }

  public void setCashCost(BigDecimal cashCost) {
    this.cashCost = cashCost;
  }

  public Toll licensePlateCost(BigDecimal licensePlateCost) {
    this.licensePlateCost = licensePlateCost;
    return this;
  }

   /**
   * License plate (video) toll cost. For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/pay-by-plate-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in California, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/pay-by-mail\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ZipCash and Pay by Mail&lt;/a&gt; in Texas, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in Florida, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;License Plate Toll&lt;/a&gt; in Colorado, Camera Charges on ETR-407, etc.
   * @return licensePlateCost
  **/
  @Schema(description = "License plate (video) toll cost. For example, <a href=\"https://tollguru.com/toll-info/california/pay-by-plate-payment\" target=\"_blank\">Pay by Plate</a> in California, <a href=\"https://tollguru.com/toll-info/texas/pay-by-mail\" target=\"_blank\">ZipCash and Pay by Mail</a> in Texas, <a href=\"https://tollguru.com/toll-info/florida/video-payment\" target=\"_blank\">Pay by Plate</a> in Florida, <a href=\"https://tollguru.com/toll-info/colorado/video-payment\" target=\"_blank\">License Plate Toll</a> in Colorado, Camera Charges on ETR-407, etc.")
  public BigDecimal getLicensePlateCost() {
    return licensePlateCost;
  }

  public void setLicensePlateCost(BigDecimal licensePlateCost) {
    this.licensePlateCost = licensePlateCost;
  }

  public Toll prepaidCardCost(BigDecimal prepaidCardCost) {
    this.prepaidCardCost = prepaidCardCost;
    return this;
  }

   /**
   * Prepaid card such as Nexpress, Nexus Card, etc. toll cost
   * @return prepaidCardCost
  **/
  @Schema(description = "Prepaid card such as Nexpress, Nexus Card, etc. toll cost")
  public BigDecimal getPrepaidCardCost() {
    return prepaidCardCost;
  }

  public void setPrepaidCardCost(BigDecimal prepaidCardCost) {
    this.prepaidCardCost = prepaidCardCost;
  }

  public Toll creditCardCost(BigDecimal creditCardCost) {
    this.creditCardCost = creditCardCost;
    return this;
  }

   /**
   * Credit card toll cost
   * @return creditCardCost
  **/
  @Schema(description = "Credit card toll cost")
  public BigDecimal getCreditCardCost() {
    return creditCardCost;
  }

  public void setCreditCardCost(BigDecimal creditCardCost) {
    this.creditCardCost = creditCardCost;
  }

  public Toll currency(String currency) {
    this.currency = currency;
    return this;
  }

   /**
   * Currency
   * @return currency
  **/
  @Schema(description = "Currency")
  public String getCurrency() {
    return currency;
  }

  public void setCurrency(String currency) {
    this.currency = currency;
  }

  public Toll tagPrimary(List<String> tagPrimary) {
    this.tagPrimary = tagPrimary;
    return this;
  }

  public Toll addTagPrimaryItem(String tagPrimaryItem) {
    if (this.tagPrimary == null) {
      this.tagPrimary = new ArrayList<String>();
    }
    this.tagPrimary.add(tagPrimaryItem);
    return this;
  }

   /**
   * A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.
   * @return tagPrimary
  **/
  @Schema(description = "A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.")
  public List<String> getTagPrimary() {
    return tagPrimary;
  }

  public void setTagPrimary(List<String> tagPrimary) {
    this.tagPrimary = tagPrimary;
  }

  public Toll tagSecondary(List<String> tagSecondary) {
    this.tagSecondary = tagSecondary;
    return this;
  }

  public Toll addTagSecondaryItem(String tagSecondaryItem) {
    if (this.tagSecondary == null) {
      this.tagSecondary = new ArrayList<String>();
    }
    this.tagSecondary.add(tagSecondaryItem);
    return this;
  }

   /**
   * All other transponders that can be used on the facility. Secondary transponders may not count towards discounts
   * @return tagSecondary
  **/
  @Schema(description = "All other transponders that can be used on the facility. Secondary transponders may not count towards discounts")
  public List<String> getTagSecondary() {
    return tagSecondary;
  }

  public void setTagSecondary(List<String> tagSecondary) {
    this.tagSecondary = tagSecondary;
  }

  public Toll licensePlatePrimary(String licensePlatePrimary) {
    this.licensePlatePrimary = licensePlatePrimary;
    return this;
  }

   /**
   * Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.
   * @return licensePlatePrimary
  **/
  @Schema(description = "Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.")
  public String getLicensePlatePrimary() {
    return licensePlatePrimary;
  }

  public void setLicensePlatePrimary(String licensePlatePrimary) {
    this.licensePlatePrimary = licensePlatePrimary;
  }

  public Toll licensePlateSecondary(String licensePlateSecondary) {
    this.licensePlateSecondary = licensePlateSecondary;
    return this;
  }

   /**
   * Name of the secondary license plate toll (video toll) collection system
   * @return licensePlateSecondary
  **/
  @Schema(description = "Name of the secondary license plate toll (video toll) collection system")
  public String getLicensePlateSecondary() {
    return licensePlateSecondary;
  }

  public void setLicensePlateSecondary(String licensePlateSecondary) {
    this.licensePlateSecondary = licensePlateSecondary;
  }

  public Toll id(BigDecimal id) {
    this.id = id;
    return this;
  }

   /**
   * Tollguru toll ID. Useful for error checking
   * @return id
  **/
  @Schema(description = "Tollguru toll ID. Useful for error checking")
  public BigDecimal getId() {
    return id;
  }

  public void setId(BigDecimal id) {
    this.id = id;
  }

  public Toll lat(BigDecimal lat) {
    this.lat = lat;
    return this;
  }

   /**
   * Approximate latitude of the toll location
   * @return lat
  **/
  @Schema(description = "Approximate latitude of the toll location")
  public BigDecimal getLat() {
    return lat;
  }

  public void setLat(BigDecimal lat) {
    this.lat = lat;
  }

  public Toll lng(BigDecimal lng) {
    this.lng = lng;
    return this;
  }

   /**
   * Approximate longitude of the toll location
   * @return lng
  **/
  @Schema(description = "Approximate longitude of the toll location")
  public BigDecimal getLng() {
    return lng;
  }

  public void setLng(BigDecimal lng) {
    this.lng = lng;
  }

  public Toll name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the toll location
   * @return name
  **/
  @Schema(description = "Name of the toll location")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Toll road(String road) {
    this.road = road;
    return this;
  }

   /**
   * Name of the toll road
   * @return road
  **/
  @Schema(description = "Name of the toll road")
  public String getRoad() {
    return road;
  }

  public void setRoad(String road) {
    this.road = road;
  }

  public Toll state(String state) {
    this.state = state;
    return this;
  }

   /**
   * State, province of the toll location
   * @return state
  **/
  @Schema(description = "State, province of the toll location")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Toll toll = (Toll) o;
    return Objects.equals(this.type, toll.type) &&
        Objects.equals(this.tagCost, toll.tagCost) &&
        Objects.equals(this.cashCost, toll.cashCost) &&
        Objects.equals(this.licensePlateCost, toll.licensePlateCost) &&
        Objects.equals(this.prepaidCardCost, toll.prepaidCardCost) &&
        Objects.equals(this.creditCardCost, toll.creditCardCost) &&
        Objects.equals(this.currency, toll.currency) &&
        Objects.equals(this.tagPrimary, toll.tagPrimary) &&
        Objects.equals(this.tagSecondary, toll.tagSecondary) &&
        Objects.equals(this.licensePlatePrimary, toll.licensePlatePrimary) &&
        Objects.equals(this.licensePlateSecondary, toll.licensePlateSecondary) &&
        Objects.equals(this.id, toll.id) &&
        Objects.equals(this.lat, toll.lat) &&
        Objects.equals(this.lng, toll.lng) &&
        Objects.equals(this.name, toll.name) &&
        Objects.equals(this.road, toll.road) &&
        Objects.equals(this.state, toll.state);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, tagCost, cashCost, licensePlateCost, prepaidCardCost, creditCardCost, currency, tagPrimary, tagSecondary, licensePlatePrimary, licensePlateSecondary, id, lat, lng, name, road, state);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Toll {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    tagCost: ").append(toIndentedString(tagCost)).append("\n");
    sb.append("    cashCost: ").append(toIndentedString(cashCost)).append("\n");
    sb.append("    licensePlateCost: ").append(toIndentedString(licensePlateCost)).append("\n");
    sb.append("    prepaidCardCost: ").append(toIndentedString(prepaidCardCost)).append("\n");
    sb.append("    creditCardCost: ").append(toIndentedString(creditCardCost)).append("\n");
    sb.append("    currency: ").append(toIndentedString(currency)).append("\n");
    sb.append("    tagPrimary: ").append(toIndentedString(tagPrimary)).append("\n");
    sb.append("    tagSecondary: ").append(toIndentedString(tagSecondary)).append("\n");
    sb.append("    licensePlatePrimary: ").append(toIndentedString(licensePlatePrimary)).append("\n");
    sb.append("    licensePlateSecondary: ").append(toIndentedString(licensePlateSecondary)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lat: ").append(toIndentedString(lat)).append("\n");
    sb.append("    lng: ").append(toIndentedString(lng)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    road: ").append(toIndentedString(road)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
