/*
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.math.BigDecimal;
/**
 * Truck
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-07-14T10:23:31.922Z[GMT]")
public class Truck {
  /**
   * Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks.
   */
  @JsonAdapter(TruckTypeEnum.Adapter.class)
  public enum TruckTypeEnum {
    TRUCK("truck"),
    TRACTORTRUCK("tractorTruck");

    private String value;

    TruckTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TruckTypeEnum fromValue(String text) {
      for (TruckTypeEnum b : TruckTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TruckTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TruckTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TruckTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TruckTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("truckType")
  private TruckTypeEnum truckType = null;

  @SerializedName("trailersCount")
  private BigDecimal trailersCount = 0;

  /**
   * List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt;
   */
  @JsonAdapter(ShippedHazardousGoodsEnum.Adapter.class)
  public enum ShippedHazardousGoodsEnum {
    EXPLOSIVE("explosive"),
    GAS("gas"),
    FLAMMABLE("flammable"),
    COMBUSTIBLE("combustible"),
    ORGANIC("organic"),
    POISON("poison"),
    RADIOACTIVE("radioActive"),
    CORROSIVE("corrosive"),
    MISCELLANEOUS("miscellaneous");

    private String value;

    ShippedHazardousGoodsEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static ShippedHazardousGoodsEnum fromValue(String text) {
      for (ShippedHazardousGoodsEnum b : ShippedHazardousGoodsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<ShippedHazardousGoodsEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ShippedHazardousGoodsEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ShippedHazardousGoodsEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ShippedHazardousGoodsEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("shippedHazardousGoods")
  private ShippedHazardousGoodsEnum shippedHazardousGoods = null;

  @SerializedName("limitedWeight")
  private BigDecimal limitedWeight = null;

  @SerializedName("weightPerAxle")
  private BigDecimal weightPerAxle = null;

  @SerializedName("height")
  private BigDecimal height = null;

  @SerializedName("width")
  private BigDecimal width = null;

  @SerializedName("length")
  private BigDecimal length = null;

  /**
   * Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.
   */
  @JsonAdapter(TunnelCategoryEnum.Adapter.class)
  public enum TunnelCategoryEnum {
    B("B"),
    C("C"),
    D("D"),
    E("E");

    private String value;

    TunnelCategoryEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TunnelCategoryEnum fromValue(String text) {
      for (TunnelCategoryEnum b : TunnelCategoryEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TunnelCategoryEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TunnelCategoryEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TunnelCategoryEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TunnelCategoryEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("tunnelCategory")
  private TunnelCategoryEnum tunnelCategory = null;

  /**
   * pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt;
   */
  @JsonAdapter(TruckRestrictionPenaltyEnum.Adapter.class)
  public enum TruckRestrictionPenaltyEnum {
    STRICT("strict"),
    SOFT("soft");

    private String value;

    TruckRestrictionPenaltyEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TruckRestrictionPenaltyEnum fromValue(String text) {
      for (TruckRestrictionPenaltyEnum b : TruckRestrictionPenaltyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TruckRestrictionPenaltyEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TruckRestrictionPenaltyEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TruckRestrictionPenaltyEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TruckRestrictionPenaltyEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("truckRestrictionPenalty")
  private TruckRestrictionPenaltyEnum truckRestrictionPenalty = null;

  public Truck truckType(TruckTypeEnum truckType) {
    this.truckType = truckType;
    return this;
  }

   /**
   * Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks.
   * @return truckType
  **/
  @Schema(description = "Specifies the vehicle type<br><strong>Note</strong>: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the <code>truckType</code> set to <code>tractorTruck</code> and the trailers count greater than 0 (for example <code>truckType: \"tractorTruck\", trailersCount: 1</code>). The truck type is irrelevant in case of restrictions common for all types of trucks.")
  public TruckTypeEnum getTruckType() {
    return truckType;
  }

  public void setTruckType(TruckTypeEnum truckType) {
    this.truckType = truckType;
  }

  public Truck trailersCount(BigDecimal trailersCount) {
    this.trailersCount = trailersCount;
    return this;
  }

   /**
   * Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4.
   * @return trailersCount
  **/
  @Schema(description = "Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4.")
  public BigDecimal getTrailersCount() {
    return trailersCount;
  }

  public void setTrailersCount(BigDecimal trailersCount) {
    this.trailersCount = trailersCount;
  }

  public Truck shippedHazardousGoods(ShippedHazardousGoodsEnum shippedHazardousGoods) {
    this.shippedHazardousGoods = shippedHazardousGoods;
    return this;
  }

   /**
   * List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt;
   * @return shippedHazardousGoods
  **/
  @Schema(description = "List of hazardous materials in the vehicle. The names correspond to <a href=\"https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\" target=\"_blank\"> HAZMAT classes 1 to 9. <br> For example, explosive is Class 1 and so on. </a>")
  public ShippedHazardousGoodsEnum getShippedHazardousGoods() {
    return shippedHazardousGoods;
  }

  public void setShippedHazardousGoods(ShippedHazardousGoodsEnum shippedHazardousGoods) {
    this.shippedHazardousGoods = shippedHazardousGoods;
  }

  public Truck limitedWeight(BigDecimal limitedWeight) {
    this.limitedWeight = limitedWeight;
    return this;
  }

   /**
   * Vehicle weight including trailers and shipped goods, in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
   * @return limitedWeight
  **/
  @Schema(description = "Vehicle weight including trailers and shipped goods, in pounds. <br> If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.")
  public BigDecimal getLimitedWeight() {
    return limitedWeight;
  }

  public void setLimitedWeight(BigDecimal limitedWeight) {
    this.limitedWeight = limitedWeight;
  }

  public Truck weightPerAxle(BigDecimal weightPerAxle) {
    this.weightPerAxle = weightPerAxle;
    return this;
  }

   /**
   * Vehicle weight per axle in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
   * @return weightPerAxle
  **/
  @Schema(description = "Vehicle weight per axle in pounds. <br> If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.")
  public BigDecimal getWeightPerAxle() {
    return weightPerAxle;
  }

  public void setWeightPerAxle(BigDecimal weightPerAxle) {
    this.weightPerAxle = weightPerAxle;
  }

  public Truck height(BigDecimal height) {
    this.height = height;
    return this;
  }

   /**
   * Vehicle height in feet. The provided value must be between 0 and 50. &lt;br&gt; If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight.
   * @return height
  **/
  @Schema(description = "Vehicle height in feet. The provided value must be between 0 and 50. <br> If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight.")
  public BigDecimal getHeight() {
    return height;
  }

  public void setHeight(BigDecimal height) {
    this.height = height;
  }

  public Truck width(BigDecimal width) {
    this.width = width;
    return this;
  }

   /**
   * Vehicle width in feet. The provided value must be between 0 and 50.
   * @return width
  **/
  @Schema(description = "Vehicle width in feet. The provided value must be between 0 and 50.")
  public BigDecimal getWidth() {
    return width;
  }

  public void setWidth(BigDecimal width) {
    this.width = width;
  }

  public Truck length(BigDecimal length) {
    this.length = length;
    return this;
  }

   /**
   * Vehicle length in feet. The provided value must be between 0 and 300.
   * @return length
  **/
  @Schema(description = "Vehicle length in feet. The provided value must be between 0 and 300.")
  public BigDecimal getLength() {
    return length;
  }

  public void setLength(BigDecimal length) {
    this.length = length;
  }

  public Truck tunnelCategory(TunnelCategoryEnum tunnelCategory) {
    this.tunnelCategory = tunnelCategory;
    return this;
  }

   /**
   * Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.
   * @return tunnelCategory
  **/
  @Schema(description = "Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.")
  public TunnelCategoryEnum getTunnelCategory() {
    return tunnelCategory;
  }

  public void setTunnelCategory(TunnelCategoryEnum tunnelCategory) {
    this.tunnelCategory = tunnelCategory;
  }

  public Truck truckRestrictionPenalty(TruckRestrictionPenaltyEnum truckRestrictionPenalty) {
    this.truckRestrictionPenalty = truckRestrictionPenalty;
    return this;
  }

   /**
   * pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt;
   * @return truckRestrictionPenalty
  **/
  @Schema(description = "pecifies the penalty type on violated truck restrictions.<br><code>strict</code>: route will not use links with a violated truck restriction at any circumstances<br><strong>Note</strong>: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.<br><code>soft</code>: route will use links with a violated truck restriction if there is no alternative to avoid them<")
  public TruckRestrictionPenaltyEnum getTruckRestrictionPenalty() {
    return truckRestrictionPenalty;
  }

  public void setTruckRestrictionPenalty(TruckRestrictionPenaltyEnum truckRestrictionPenalty) {
    this.truckRestrictionPenalty = truckRestrictionPenalty;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Truck truck = (Truck) o;
    return Objects.equals(this.truckType, truck.truckType) &&
        Objects.equals(this.trailersCount, truck.trailersCount) &&
        Objects.equals(this.shippedHazardousGoods, truck.shippedHazardousGoods) &&
        Objects.equals(this.limitedWeight, truck.limitedWeight) &&
        Objects.equals(this.weightPerAxle, truck.weightPerAxle) &&
        Objects.equals(this.height, truck.height) &&
        Objects.equals(this.width, truck.width) &&
        Objects.equals(this.length, truck.length) &&
        Objects.equals(this.tunnelCategory, truck.tunnelCategory) &&
        Objects.equals(this.truckRestrictionPenalty, truck.truckRestrictionPenalty);
  }

  @Override
  public int hashCode() {
    return Objects.hash(truckType, trailersCount, shippedHazardousGoods, limitedWeight, weightPerAxle, height, width, length, tunnelCategory, truckRestrictionPenalty);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Truck {\n");
    
    sb.append("    truckType: ").append(toIndentedString(truckType)).append("\n");
    sb.append("    trailersCount: ").append(toIndentedString(trailersCount)).append("\n");
    sb.append("    shippedHazardousGoods: ").append(toIndentedString(shippedHazardousGoods)).append("\n");
    sb.append("    limitedWeight: ").append(toIndentedString(limitedWeight)).append("\n");
    sb.append("    weightPerAxle: ").append(toIndentedString(weightPerAxle)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    width: ").append(toIndentedString(width)).append("\n");
    sb.append("    length: ").append(toIndentedString(length)).append("\n");
    sb.append("    tunnelCategory: ").append(toIndentedString(tunnelCategory)).append("\n");
    sb.append("    truckRestrictionPenalty: ").append(toIndentedString(truckRestrictionPenalty)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
